﻿Partial Class webPagoPrestamo
    Inherits System.Web.UI.Page
    Dim aux As New wsDatos.Service
    Sub CargarTipoMovimientos()
        Try
            'Creación de la cadena SQL para cargar 
            'todos los tipos de movimientos permitidos
            Dim sql = "Select *From tbTipoMovimientos"
            'Se crea un DataSet para cargar los movimientos
            Dim dsTipoMov As New Data.DataSet
            'Se invoca al método ObtenerDatos
            aux.ObtenerDatos(sql, dsTipoMov)
            'Se configura el dropdownlist2
            With DropDownList2
                'origen de datos el DataSet
                .DataSource = dsTipoMov.Tables(0).DefaultView
                'El valor de datos para utilizar
                .DataValueField = "TipoMovId"
                'El valor de datos presentados
                .DataTextField = "Descripcion"
                .DataBind()
            End With
        Catch ex As Exception
        End Try
    End Sub

    Sub CargarClaseMovimientos()
        Try
            Dim sql = "Select *From tbClaseMovimientos"
            Dim dsClaseMov As New Data.DataSet
            aux.ObtenerDatos(sql, dsClaseMov)
            With DropDownList1
                .DataSource = dsClaseMov.Tables(0).DefaultView
                .DataValueField = "ClaseMovId"
                .DataTextField = "Descripcion"
                .DataBind()
            End With
        Catch ex As Exception
        End Try
    End Sub
    Sub CargarCuentasCliente()
        Try
            Dim sql = "Select *From tbCuentas Where ClienteID='" & Session("IdCliente") & "'"
            Dim dsCuentasClientes As New Data.DataSet
            aux.ObtenerDatos(sql, dsCuentasClientes)
            With DropDownList3
                .DataSource = dsCuentasClientes.Tables(0).DefaultView
                .DataValueField = "CuentaID"
                .DataTextField = "CuentaID"
                .DataBind()
            End With
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Sub RealizarPago()
        'Se crea la cadena SQL para la actualización del saldo del cliente
        Dim sql = "Update tbCuentas Set Saldo = Saldo - " & Convert.ToDouble(TextBox1.Text) & _
                  " Where CuentaID = '" & DropDownList3.Text & "'"
        'Se invoca el método ActualizarDatos de la instancia del servicio Web
        'en este caso para actualizar la cuenta del cliente (rebajar)
        If aux.ActualizarDatos(sql, "") = True Then
            'Se registra el movimiento correspondiente (histórico)
            'Invocando el método AgregarMovimiento de la instancia del servicio Web
            If aux.AgregarMovimiento(Label3.Text, DropDownList2.Text, DropDownList1.Text, Session("IdCliente"), DropDownList3.Text, Now, Convert.ToDouble(TextBox1.Text), TextBox2.Text) = True Then
                Response.Write("<script>alert('El pago fue realizado exitosamente!')</script>")
                btnAplicarPago.Enabled = True
            End If
        End If
    End Sub
    Sub VerificarSaldo()
        Dim sql = "Select *From tbCuentas Where CuentaID='" & DropDownList3.Text & "'"
        Dim dsCuenta As New Data.DataSet
        btnAplicarPago.Enabled = False
        aux.ObtenerDatos(sql, dsCuenta)
        Dim Saldo As Double = dsCuenta.Tables(0).Rows(0).Item(5)
        Dim Pago As Double = Convert.ToDouble(TextBox1.Text)
        If Saldo > Pago Then
            RealizarPago()
        Else
            'Desplegamos un mensaje si no se puede realizar la transaccion.
            Response.Write("<script>alert('Esta cuenta sin saldo o saldo insuficiente!')</script>")
        End If
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Page.Title = "Pago de préstamos de " & Session("Usuario")
        Label1.Text = Session("IdCliente")
        Label2.Text = Session("Usuario")
        Label3.Text = Session("NumeroCuenta")
        'Para que no se ejecuten los procedimientos del formulario Web
        'Cada vez que se refresque la página.
        If Not IsPostBack Then
            CargarClaseMovimientos()
            CargarTipoMovimientos()
            CargarCuentasCliente()
        End If
        'Por defecto se muestre la posición 1 
        DropDownList2.SelectedIndex = 1
        'Se inhabilitan los dropdownlist
        DropDownList1.Enabled = False
        DropDownList2.Enabled = False
    End Sub

    Protected Sub btnAplicarPago_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAplicarPago.Click
        VerificarSaldo()
    End Sub
End Class
