﻿
Partial Class webPagos
    Inherits System.Web.UI.Page
    Dim aux As New wsDatos.Service
    Sub CargarTipoServicio()
        Try
            Dim sql = "Select *From tbTipoServicios"
            Dim dsTipoServicios As New Data.DataSet
            aux.ObtenerDatos(sql, dsTipoServicios)
            With DropDownList2
                .DataSource = dsTipoServicios.Tables(0).DefaultView
                .DataValueField = "TipoServicioID"
                .DataTextField = "Descripcion"
                .DataBind()
            End With
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Sub CargarCuentasCliente()
        Try
            Dim sql = "Select *From tbCuentas Where ClienteID='" & Session("IdCliente") & "'"
            Dim dsCuentasClientes As New Data.DataSet
            aux.ObtenerDatos(sql, dsCuentasClientes)
            With DropDownList1
                .DataSource = dsCuentasClientes.Tables(0).DefaultView
                .DataValueField = "CuentaID"
                .DataTextField = "CuentaID"
                .DataBind()
            End With
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Function VerificarSaldo() As Double
        Dim sql = "Select *From tbCuentas Where CuentaID='" & DropDownList1.Text & "'"
        Dim dsSaldoCuenta As New Data.DataSet
        aux.ObtenerDatos(sql, dsSaldoCuenta)
        Return dsSaldoCuenta.Tables(0).Rows(0).Item(5)
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Page.Title = "Pagos de Servicios Públicos. Usuario " & Session("Usuario")
        Label1.Text = Session("IdCliente")
        Label2.Text = Session("Usuario")
        If Not IsPostBack Then
            CargarCuentasCliente()
            CargarTipoServicio()
        End If
    End Sub

    Protected Sub btnConsultar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnConsultar.Click
        Try
            Dim sql = "Select *From tbServiciosPublicos Where DocumentoID='" & TextBox1.Text & "' " & _
                      "And TipoServicioID='" & DropDownList2.SelectedValue & "'"
            Dim dsServicioPublico As New Data.DataSet
            aux.ObtenerDatos(sql, dsServicioPublico)
            If dsServicioPublico.Tables(0).Rows.Count > 0 Then
                If IsDBNull(dsServicioPublico.Tables(0).Rows(0).Item(3)) Then
                    Label3.Text = dsServicioPublico.Tables(0).Rows(0).Item(2)
                    btnPagar.Enabled = True
                Else
                    Response.Write("<script>alert('Recibo Ya fue cancelado!')</script>")
                End If
            Else
                Response.Write("<script>alert('Recibo no Existe!')</script>")
            End If
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try

    End Sub

    Protected Sub btnPagar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnPagar.Click
        Dim SaldoCuenta As Double = VerificarSaldo()
        Dim MontoPago As Double = Convert.ToDouble(Label3.Text)
        If SaldoCuenta <= MontoPago Then
            Response.Write("<script>alert('Fondos insuficientes en la cuenta!')</script>")
            Exit Sub
        End If

        Dim SQL = "Update tbServiciosPublicos Set Fecha_Pago = '" & Now & "' Where DocumentoID='" & TextBox1.Text & "' " & _
                      "And TipoServicioID='" & DropDownList2.SelectedValue & "'"
        If aux.ActualizarDatos(SQL, "") = True Then
            SQL = "Update tbCuentas Set Saldo = Saldo - " & MontoPago & " Where CuentaID='" & DropDownList1.Text & "'"
            If aux.ActualizarDatos(SQL, "") = True Then
                Response.Write("<script>alert('El recibo fue cancelado exitosamente!')</script>")
                btnPagar.Enabled = False
            End If
        End If
    End Sub
End Class
