﻿
Partial Class webConsultaCuenta
    Inherits System.Web.UI.Page
    Dim aux As New wsDatos.Service
    Sub CargarMovCuentas()
        Try
            'Asignamos los valores de los componentes Calendar
            'a dos variables de tipo fecha (date)
            Dim Fecha1 As Date = Calendar1.SelectedDate.Date
            Dim Fecha2 As Date = Calendar2.SelectedDate.Date
            'Creamos la sentencia SQL para efectuar la consulta de todas cuentas que pertenecen al cliente actual.
            Dim sql = "SELECT  tbMovimientos.OperacionID As [Operacion No], tbClaseMovimientos.Descripcion, tbMovimientos.CuentaID As [Cuenta No.]," & _
                             "tbMovimientos.Fecha_Movimiento As [Fecha Movimiento], tbMovimientos.Monto_Movimiento As [Monto Movimiento]," & _
                             "tbMovimientos.Detalle_Movimiento As [Detalle Movimiento] " & _
                             " FROM   tbClaseMovimientos INNER JOIN tbMovimientos ON tbClaseMovimientos.ClaseMovID = tbMovimientos.ClaseMovID " & _
                             " Where (tbMovimientos.CuentaID='" & Session("NumeroCuenta") & "') AND (tbMovimientos.Fecha_Movimiento >= CONVERT(DATETIME,'" & Fecha1.Year & _
                             "-" & Fecha1.Month & "-" & Fecha1.Day & " 00:00:00'" & ",102))" & " And (tbMovimientos.Fecha_Movimiento <=" & _
                             "CONVERT(DATETIME,'" & Fecha2.Year & "-" & Fecha2.Month & "-" & Fecha2.Day & " 00:00:00'" & ",102))"
            'Declaramos un DataSet para cargar en el los datos que se generan en la consulta.
            Dim dsMovCuentas As New Data.DataSet
            'Invocamos el método ObtenerDatos de la instancia del servicio Web, cuyos parámetros son la cadena SQL y el DataSet vacio
            aux.ObtenerDatos(sql, dsMovCuentas)
            'Cargamos los datos del DataSet en el GridView
            GridView1.DataSource = dsMovCuentas.Tables(0).DefaultView
            GridView1.DataBind()
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Visualiza el nombre completo del usuario en el título de la página.
        Page.Title = "Consulta de Movimientos de una Cuenta de " & Session("Usuario")
        'Carga en las etiquetas corresopondientes los valores cargados en las sesiones
        lblNumeroCuenta.Text = Session("NumeroCuenta")
        lblFechaApertura.Text = Session("FechaCuenta")
        lblSaldoActual.Text = Session("MontoCuenta")
    End Sub

    Protected Sub btnConsultar_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnConsultar.Click
        CargarMovCuentas()
    End Sub
End Class
